package praktikum;


import java.math.BigInteger;
import java.util.*;
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

/**
 * Testprogramm für die erste Aufgabe.
 *
 * Die in der Klasse RSA implementierten Methoden können mit diesem Programm
 * getestet werden. 
 */

public class Aufgabe1 extends JFrame implements WindowListener,ActionListener {

	private static final long serialVersionUID = 1L;

	
    /* Fuer Internationalisierung */
    public static ResourceBundle messages;

    private Container pane;
    private int WIDTH=400;
    private int HEIGHT=400;
    private GridBagLayout GL;
    
    private JLabel Label1;
    private JLabel Label2;
    
    private JTextField Text1;
    private JTextArea  Text2;
    private JButton test;
    private JButton exit;
    
    public Aufgabe1(){
	super(messages.getString("Aufgabe1RSASignTest"));
	this.setSize(WIDTH,HEIGHT);
	this.addWindowListener(this);	

	pane = this.getContentPane();
	GL = new GridBagLayout();
	pane.setLayout(GL);
	GridBagConstraints GB = new GridBagConstraints();
	
	Label1 = new JLabel(messages.getString("Aufgabe1Label1"));
	
	GB.gridx = 0;
	GB.gridy = 0;
	GB.gridwidth = 2;
	GB.gridheight = 1;
	GB.weightx = 1;
	GB.weighty = 0.1;
	GB.insets = new Insets(10,10,0,10);
	GB.ipadx = 0;
	GB.ipady = 0;
	GB.fill = GridBagConstraints.HORIZONTAL;
	GB.anchor = GridBagConstraints.NORTH;
	GL.setConstraints(Label1,GB);
	pane.add(Label1);
	
	Text1 = new JTextField(40);
	JScrollPane js = new JScrollPane(Text1);
	js.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_AS_NEEDED);
	js.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_NEVER);

	GB.gridx = 0;
	GB.gridy = 1;
	GB.gridwidth = 2;
	GB.gridheight = 1;
	GB.weightx = 1;
	GB.weighty = 0.1;
	GB.insets = new Insets(10,10,10,10);
	GB.ipadx = 0;
	GB.ipady = 20;
	GB.fill = GridBagConstraints.HORIZONTAL;
	GB.anchor = GridBagConstraints.NORTH;
	GL.setConstraints(js,GB);
	pane.add(js);
	
	test = new JButton(messages.getString("Aufgabe1Test"));
	
	GB.gridx = 0;
	GB.gridy = 2;
	GB.gridwidth = 1;
	GB.gridheight = 1;
	GB.weightx = 0.5;
	GB.weighty = 0.1;
	GB.insets = new Insets(10,10,10,10);
	GB.ipadx = 0;
	GB.ipady = 0;
	GB.fill = GridBagConstraints.NONE;
	GB.anchor = GridBagConstraints.EAST;
	GL.setConstraints(test,GB);
	pane.add(test);
	
	exit = new JButton(messages.getString("Aufgabe1Exit"));
	
	GB.gridx = 1;
	GB.gridy = 2;
	GB.gridwidth = 1;
	GB.gridheight = 1;
	GB.weightx = 0.5;
	GB.weighty = 0.1;
	GB.insets = new Insets(10,10,10,10);
	GB.ipadx = 0;
	GB.ipady = 0;
	GB.fill = GridBagConstraints.NONE;
	GB.anchor = GridBagConstraints.WEST;
	GL.setConstraints(exit,GB);
	pane.add(exit);
		
	Label2 = new JLabel(messages.getString("Aufgabe1Erg"));
		
	GB.gridx = 0;
	GB.gridy = 3;
	GB.gridwidth = 2;
	GB.gridheight = 1;
	GB.weightx = 1;
	GB.weighty = 0.1;
	GB.insets = new Insets(10,10,0,10);
	GB.ipadx = 0;
	GB.ipady = 0;
	GB.fill = GridBagConstraints.HORIZONTAL;
	GB.anchor = GridBagConstraints.NORTH;
	GL.setConstraints(Label2,GB);
	pane.add(Label2);

	Text2 = new JTextArea(10,40);
	Text2.setEditable(false);
	JScrollPane js2 = new JScrollPane(Text2);
	js2.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_AS_NEEDED);
	js2.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_NEVER);

	GB.gridx = 0;
	GB.gridy = 4;
	GB.gridwidth = 2;
	GB.gridheight = 1;
	GB.weightx = 1;
	GB.weighty = 1;
	GB.insets = new Insets(10,10,10,10);
	GB.ipadx = 0;
	GB.ipady = 20;
	GB.fill = GridBagConstraints.BOTH;
	GB.anchor = GridBagConstraints.SOUTH;
	GL.setConstraints(js2,GB);
	pane.add(js2);
	
	test.addActionListener(this);
	exit.addActionListener(this);

	this.pack();
    }

    public int getWIDTH(){
	return WIDTH;	
    }

    public int getHEIGHT(){
	return HEIGHT;	
    }

    /*
     * ActionListener Methoden
     */
    
    public void actionPerformed (ActionEvent e) {
	Object object = e.getSource();
	if (object == exit){
	    System.exit(0);
	}
	else if (object == test){
	    startRSATest();
	}
    }
    
    
    /*
     * WindowListener Methoden
     */
    
    public void windowActivated(WindowEvent event) {}
    public void windowClosed(WindowEvent event) {}
    public void windowClosing(WindowEvent event) {
	System.exit(0);
    }
    public void windowDeactivated(WindowEvent event) {}
    public void windowDeiconified(WindowEvent event) {}
    public void windowIconified(WindowEvent event) {}
    public void windowOpened(WindowEvent event) {}

    public static void main(String args[]){
	
	
	/* Der folgende Teil ist nötig für die Internationalisierung */
	Locale currentLocale; 
	currentLocale = Locale.getDefault(); 
	messages = ResourceBundle.getBundle("praktikum.localmessages",currentLocale); 
 	
	
	/* Rest der Main-Methode */
	try{
	    Aufgabe1 fenster = new Aufgabe1();
	    fenster.setVisible(true);
	}
      	catch(Exception e){
	    System.out.println(messages.getString("Aufgabe1FenstErr")+" " + e.getMessage());
	    System.exit(1);
	}
    }


    public void startRSATest(){
	BigInteger m = null;
      	try{
	    m = new BigInteger(Text1.getText());
	    
	    /** RSA-Schlüssellänge in bit */
	    
	    int k = 1024;
	    
	    Text2.append(messages.getString("Aufgabe1KeyGen"));
	    update(getGraphics());
	    RSAKeyGenerator kGen = new RSAKeyGenerator(k);
	    /** Signierschlüssel */
	    
	    RSAPrivateKey privKey = kGen.getPrivateKey();
	    /** Testschlüssel */
	    
	    RSAPublicKey pubKey = kGen.getPublicKey();

	    if (m.compareTo(pubKey.n) >= 0){
		throw new Exception(messages.getString("Aufgabe1MesgErr"));
	    }

	    RSA myRSA = new RSA();
	    
	    BigInteger sig = myRSA.sign(privKey, m);
	    Text2.append(messages.getString("Aufgabe1Sign")+" "+sig.toString()+"\n");
	    
	    if(! myRSA.test(pubKey, m,sig)){
		Text2.append(messages.getString("Aufgabe1Err"));
	    }else{
		Text2.append(messages.getString("Aufgabe1SigKorr"));
	    };
	}catch(Exception e){
	    Text2.append(messages.getString("Aufgabe1Err2")+" "+e.getMessage());
	};
    };
};

