package praktikum;

import java.math.BigInteger;
import java.util.*;
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

/**
 * Testprogramm für die dritte Aufgabe.
 *
 * Mit diesem Programm wird die Methode hash aus der Klasse Damgard getestet.
 */
/**
 * EN Program for testing the third task.
 * 
 * With this program the method hash from the class Damgard can be testet.
 */
public class Aufgabe3 extends JFrame implements WindowListener, ActionListener {

	private static final long serialVersionUID = 1L;

	/* EN For internationalization */
	/* DE Fuer Internationalisierung */
	public static ResourceBundle messages;

	private Container pane;
	private int WIDTH = 400;
	private int HEIGHT = 400;
	private GridBagLayout GL;

	private JLabel Label1;
	private JLabel Label2;

	private JTextField Text1;
	private JTextArea Text2;
	private JButton test;
	private JButton exit;
	private JButton testHash;

	public Aufgabe3() {
		super(messages.getString("Aufgabe3DamHash"));
		this.setSize(WIDTH, HEIGHT);
		this.addWindowListener(this);

		pane = this.getContentPane();
		GL = new GridBagLayout();
		pane.setLayout(GL);
		GridBagConstraints GB = new GridBagConstraints();

		Label1 = new JLabel(messages.getString("Aufgabe3HashMsg"));

		GB.gridx = 0;
		GB.gridy = 0;
		GB.gridwidth = 3;
		GB.gridheight = 1;
		GB.weightx = 1;
		GB.weighty = 0.1;
		GB.insets = new Insets(10, 10, 0, 10);
		GB.ipadx = 0;
		GB.ipady = 0;
		GB.fill = GridBagConstraints.HORIZONTAL;
		GB.anchor = GridBagConstraints.NORTH;
		GL.setConstraints(Label1, GB);
		pane.add(Label1);

		Text1 = new JTextField(40);
		JScrollPane js = new JScrollPane(Text1);
		js
				.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_AS_NEEDED);
		js.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_NEVER);

		GB.gridx = 0;
		GB.gridy = 1;
		GB.gridwidth = 3;
		GB.gridheight = 1;
		GB.weightx = 1;
		GB.weighty = 0.1;
		GB.insets = new Insets(10, 10, 10, 10);
		GB.ipadx = 0;
		GB.ipady = 20;
		GB.fill = GridBagConstraints.HORIZONTAL;
		GB.anchor = GridBagConstraints.NORTH;
		GL.setConstraints(js, GB);
		pane.add(js);

		test = new JButton(messages.getString("Aufgabe3Hash"));

		GB.gridx = 0;
		GB.gridy = 2;
		GB.gridwidth = 1;
		GB.gridheight = 1;
		GB.weightx = 0.5;
		GB.weighty = 0.1;
		GB.insets = new Insets(10, 10, 10, 10);
		GB.ipadx = 0;
		GB.ipady = 0;
		GB.fill = GridBagConstraints.NONE;
		GB.anchor = GridBagConstraints.EAST;
		GL.setConstraints(test, GB);
		pane.add(test);

		testHash = new JButton(messages.getString("Aufgabe3Test"));

		GB.gridx = 1;
		GB.gridy = 2;
		GB.gridwidth = 1;
		GB.gridheight = 1;
		GB.weightx = 0.5;
		GB.weighty = 0.1;
		GB.insets = new Insets(10, 10, 10, 10);
		GB.ipadx = 0;
		GB.ipady = 0;
		GB.fill = GridBagConstraints.NONE;
		GB.anchor = GridBagConstraints.CENTER;
		GL.setConstraints(testHash, GB);
		pane.add(testHash);

		exit = new JButton(messages.getString("Aufgabe3Exit"));

		GB.gridx = 2;
		GB.gridy = 2;
		GB.gridwidth = 1;
		GB.gridheight = 1;
		GB.weightx = 0.5;
		GB.weighty = 0.1;
		GB.insets = new Insets(10, 10, 10, 10);
		GB.ipadx = 0;
		GB.ipady = 0;
		GB.fill = GridBagConstraints.NONE;
		GB.anchor = GridBagConstraints.WEST;
		GL.setConstraints(exit, GB);
		pane.add(exit);

		Label2 = new JLabel(messages.getString("Aufgabe3Erg"));

		GB.gridx = 0;
		GB.gridy = 3;
		GB.gridwidth = 3;
		GB.gridheight = 1;
		GB.weightx = 1;
		GB.weighty = 0.1;
		GB.insets = new Insets(10, 10, 0, 10);
		GB.ipadx = 0;
		GB.ipady = 0;
		GB.fill = GridBagConstraints.HORIZONTAL;
		GB.anchor = GridBagConstraints.NORTH;
		GL.setConstraints(Label2, GB);
		pane.add(Label2);

		Text2 = new JTextArea(10, 40);
		Text2.setEditable(false);
		JScrollPane js2 = new JScrollPane(Text2);
		js2
				.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_AS_NEEDED);
		js2
				.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED);

		GB.gridx = 0;
		GB.gridy = 4;
		GB.gridwidth = 3;
		GB.gridheight = 1;
		GB.weightx = 1;
		GB.weighty = 1;
		GB.insets = new Insets(10, 10, 10, 10);
		GB.ipadx = 0;
		GB.ipady = 20;
		GB.fill = GridBagConstraints.BOTH;
		GB.anchor = GridBagConstraints.SOUTH;
		GL.setConstraints(js2, GB);
		pane.add(js2);

		test.addActionListener(this);
		testHash.addActionListener(this);
		exit.addActionListener(this);

		this.pack();
	}

	public int getWIDTH() {
		return WIDTH;
	}

	public int getHEIGHT() {
		return HEIGHT;
	}

	/*
	 * DE ActionListener Methoden
	 */
	/*
	 * EN ActionListener methods
	 */
	public void actionPerformed(ActionEvent e) {
		Object object = e.getSource();
		if (object == exit) {
			System.exit(0);
		} else if (object == test) {
			startHash();
		} else if (object == testHash) {
			checkHash();
		}
	}

	/*
	 * DE WindowListener Methoden
	 */
	/*
	 * EN WindowListener methods
	 */
	public void windowActivated(WindowEvent event) {
	}

	public void windowClosed(WindowEvent event) {
	}

	public void windowClosing(WindowEvent event) {
		System.exit(0);
	}

	public void windowDeactivated(WindowEvent event) {
	}

	public void windowDeiconified(WindowEvent event) {
	}

	public void windowIconified(WindowEvent event) {
	}

	public void windowOpened(WindowEvent event) {
	}

	public static void main(String args[]) {
		/* EN The following part is used for the internationalization */
		/* DE Der folgende Teil ist nötig für die Internationalisierung */
		Locale currentLocale;
		currentLocale = Locale.getDefault();
		messages = ResourceBundle.getBundle("praktikum.localmessages",
				currentLocale);

		/* EN rest of the main method */
		/* DE Rest der Main-Methode */
		try {
			Aufgabe3 fenster = new Aufgabe3();
			fenster.setVisible(true);
		} catch (Exception e) {
			System.out.println(messages.getString("Aufgabe3FenstErr") + " "
					+ e.getMessage());
			System.exit(1);
		}
	}

	/**
	 * DE Testen des Hashalgorithmus mit einigen Testwerten
	 */
	/**
	 * EN Testing of the hash algorithm with a few test values
	 */
	public void checkHash() {
		Text2.append(messages.getString("Aufgabe3TestHash2"));
		Text2.append(messages.getString("Aufgabe3TestHash2"));
		DamgardKey checkKey = new DamgardKey();
		/* DE vorgegebene Schluessel */
		/* EN given keys */
		checkKey.n = new BigInteger("868017937733256735401135309369");
		checkKey.r = new BigInteger("286503146379168102045488060553");
		Text2.append(messages.getString("Aufgabe3TestKey") + checkKey.n);
		Text2.append("\n              r=" + checkKey.r);
		/* DE vorgegebene Nachrichten */
		/* EN given messages */
		BigInteger m[] = new BigInteger[7];
		m[0] = new BigInteger("1111111111111");
		m[1] = new BigInteger("2222222222222");
		m[2] = new BigInteger("3333333333333");
		m[3] = new BigInteger("4444444444444");
		m[4] = new BigInteger("5555555555555");
		m[5] = new BigInteger("6666666666666");
		m[6] = new BigInteger("7777777777777");
		/* DE vorgegebene Hash-Ergebnisse */
		/* EN given hash results */
		BigInteger h[] = new BigInteger[7];
		h[0] = new BigInteger("631287537119025916885181555304");
		h[1] = new BigInteger("328282694013336326010818210834");
		h[2] = new BigInteger("394048472408402058111895178744");
		h[3] = new BigInteger("523373476679814306208149118000");
		h[4] = new BigInteger("236423930241418003489204682695");
		h[5] = new BigInteger("830620775967875286647939736171");
		h[6] = new BigInteger("444816880671126504955479193043");

		Damgard myDamgard = new Damgard();
		BigInteger hComp[] = new BigInteger[7];
		boolean OK = true;
		for (int i = 0; i < 7; i++) {
			Text2.append(messages.getString("Aufgabe3Msg") + m[i]);
			Text2.append(messages.getString("Aufgabe3korrHash") + h[i]);
			hComp[i] = myDamgard.hash(checkKey, m[i]);
			Text2.append(messages.getString("Aufgabe3berHash") + hComp[i]
					+ "\n");
			if (!h[i].equals(hComp[i])) {
				OK = false;
			}
		}

		if (OK) {
			Text2.append(messages.getString("Aufgabe3HashFktKorr"));
		} else {
			Text2.append(messages.getString("Aufgabe3HashFktErr"));
		}
	}

	/**
	 * DE Schluesselerzeugung Berechnen des Hashwertes einer eingegebenen
	 * Nachricht
	 */
	/**
	 * EN key generation, calculate the hash value of a given message
	 */
	public void startHash() {
		BigInteger m = null;
		try {
			m = new BigInteger(Text1.getText());

			/** DE Damgard-Schlüssellänge in bit */
			/** EN Damgard key length in bits */
			int k = 100;

			Text2.append(messages.getString("Aufgabe3KeyGen"));
			update(getGraphics());
			DamgardKeyGenerator kGen = new DamgardKeyGenerator(k);
			DamgardKey key = kGen.getKey();

			Damgard myDamgard = new Damgard();

			BigInteger hash = myDamgard.hash(key, m);
			Text2.append(messages.getString("Aufgabe3HashMsg") + " "
					+ hash.toString() + "\n");

		} catch (Exception e) {
			Text2.append(messages.getString("Aufgabe3ErrExc") + " "
					+ e.getMessage());
			e.printStackTrace();
		}
		;
	};
};
