package praktikum;

import java.math.BigInteger;
import java.util.*;
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

/**
 * Testprogramm für die vierte Aufgabe.
 *
 * Die in der Klasse GMR implementierte Methode kann mit diesem Programm
 * getestet werden. 
 */
/**
 * EN Program for testing fourth task
 * 
 * The methods which are implemented in the class GMR can be tested with this
 * program.
 */
public class Aufgabe4 extends JFrame implements WindowListener, ActionListener {

	private static final long serialVersionUID = 1L;

	/* EN For internationalization */
	/* DE Fuer Internationalisierung */
	public static ResourceBundle messages;

	private Container pane;
	private int WIDTH = 400;
	private int HEIGHT = 400;
	private GridBagLayout GL;

	private JLabel Label1;
	private JLabel Label2;

	private JTextField Text1;
	private JTextArea Text2;
	private JButton test;
	private JButton exit;

	public Aufgabe4() {
		super(messages.getString("Aufgabe4GMRSignTest"));
		this.setSize(WIDTH, HEIGHT);
		this.addWindowListener(this);

		pane = this.getContentPane();
		GL = new GridBagLayout();
		pane.setLayout(GL);
		GridBagConstraints GB = new GridBagConstraints();

		Label1 = new JLabel(messages.getString("Aufgabe4SignMsg"));

		GB.gridx = 0;
		GB.gridy = 0;
		GB.gridwidth = 2;
		GB.gridheight = 1;
		GB.weightx = 1;
		GB.weighty = 0.1;
		GB.insets = new Insets(10, 10, 0, 10);
		GB.ipadx = 0;
		GB.ipady = 0;
		GB.fill = GridBagConstraints.HORIZONTAL;
		GB.anchor = GridBagConstraints.NORTH;
		GL.setConstraints(Label1, GB);
		pane.add(Label1);

		Text1 = new JTextField(40);
		JScrollPane js = new JScrollPane(Text1);
		js
				.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_AS_NEEDED);
		js.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_NEVER);

		GB.gridx = 0;
		GB.gridy = 1;
		GB.gridwidth = 2;
		GB.gridheight = 1;
		GB.weightx = 1;
		GB.weighty = 0.1;
		GB.insets = new Insets(10, 10, 10, 10);
		GB.ipadx = 0;
		GB.ipady = 20;
		GB.fill = GridBagConstraints.HORIZONTAL;
		GB.anchor = GridBagConstraints.NORTH;
		GL.setConstraints(js, GB);
		pane.add(js);

		test = new JButton(messages.getString("Aufgabe4Test"));

		GB.gridx = 0;
		GB.gridy = 2;
		GB.gridwidth = 1;
		GB.gridheight = 1;
		GB.weightx = 0.5;
		GB.weighty = 0.1;
		GB.insets = new Insets(10, 10, 10, 10);
		GB.ipadx = 0;
		GB.ipady = 0;
		GB.fill = GridBagConstraints.NONE;
		GB.anchor = GridBagConstraints.EAST;
		GL.setConstraints(test, GB);
		pane.add(test);

		exit = new JButton(messages.getString("Aufgabe4Exit"));

		GB.gridx = 1;
		GB.gridy = 2;
		GB.gridwidth = 1;
		GB.gridheight = 1;
		GB.weightx = 0.5;
		GB.weighty = 0.1;
		GB.insets = new Insets(10, 10, 10, 10);
		GB.ipadx = 0;
		GB.ipady = 0;
		GB.fill = GridBagConstraints.NONE;
		GB.anchor = GridBagConstraints.WEST;
		GL.setConstraints(exit, GB);
		pane.add(exit);

		Label2 = new JLabel(messages.getString("Aufgabe4Erg"));

		GB.gridx = 0;
		GB.gridy = 3;
		GB.gridwidth = 2;
		GB.gridheight = 1;
		GB.weightx = 1;
		GB.weighty = 0.1;
		GB.insets = new Insets(10, 10, 0, 10);
		GB.ipadx = 0;
		GB.ipady = 0;
		GB.fill = GridBagConstraints.HORIZONTAL;
		GB.anchor = GridBagConstraints.NORTH;
		GL.setConstraints(Label2, GB);
		pane.add(Label2);

		Text2 = new JTextArea(10, 40);
		Text2.setEditable(false);
		JScrollPane js2 = new JScrollPane(Text2);
		js2
				.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_AS_NEEDED);
		js2.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_NEVER);

		GB.gridx = 0;
		GB.gridy = 4;
		GB.gridwidth = 2;
		GB.gridheight = 1;
		GB.weightx = 1;
		GB.weighty = 1;
		GB.insets = new Insets(10, 10, 10, 10);
		GB.ipadx = 0;
		GB.ipady = 20;
		GB.fill = GridBagConstraints.BOTH;
		GB.anchor = GridBagConstraints.SOUTH;
		GL.setConstraints(js2, GB);
		pane.add(js2);

		test.addActionListener(this);
		exit.addActionListener(this);

		this.pack();
	}

	public int getWIDTH() {
		return WIDTH;
	}

	public int getHEIGHT() {
		return HEIGHT;
	}

	/*
	 * DE ActionListener Methoden
	 */
	/*
	 * EN ActionListener methods
	 */
	public void actionPerformed(ActionEvent e) {
		Object object = e.getSource();
		if (object == exit) {
			System.exit(0);
		} else if (object == test) {
			startGMRTest();
		}
	}

	/*
	 * DE WindowListener Methoden
	 */
	/*
	 * EN WindowListener methods
	 */
	public void windowActivated(WindowEvent event) {
	}

	public void windowClosed(WindowEvent event) {
	}

	public void windowClosing(WindowEvent event) {
		System.exit(0);
	}

	public void windowDeactivated(WindowEvent event) {
	}

	public void windowDeiconified(WindowEvent event) {
	}

	public void windowIconified(WindowEvent event) {
	}

	public void windowOpened(WindowEvent event) {
	}

	public static void main(String args[]) {
		/* EN The following part is used for the internationalization */
		/* DE Der folgende Teil ist nötig für die Internationalisierung */
		Locale currentLocale;
		currentLocale = Locale.getDefault();
		messages = ResourceBundle.getBundle("praktikum.localmessages", currentLocale);

		/* EN rest of the main method */
		/* DE Rest der Main-Methode */
		try {
			Aufgabe4 fenster = new Aufgabe4();
			fenster.setVisible(true);
		} catch (Exception e) {
			System.out.println(messages.getString("Aufgabe4FenstErst") + " "
					+ e.getMessage());
			System.exit(1);
		}
	}

	public void startGMRTest() {
		BigInteger m = null;
		try {
			m = new BigInteger(Text1.getText());

			if (m.compareTo(BigInteger.ZERO) < 0) {
				throw new Exception(messages.getString("Aufgabe4Zahl"));
			}

			/** DE GMR-Schlüssellänge in bit */
			/** EN GMR key length in bits */
			int k = 1024;

			Text2.append(messages.getString("Aufgabe4GMRKeyGen"));
			update(getGraphics());
			GMRKeyGenerator kGen = new GMRKeyGenerator(k);
			/** DE Signierschlüssel */
			/** EN key for signing */
			GMRPrivateKey privKey = kGen.getPrivateKey();
			/** DE Testschlüssel */
			/** EN key for testing */
			GMRPublicKey pubKey = kGen.getPublicKey();

			if (m.compareTo(pubKey.n) >= 0) {
				throw new Exception(messages.getString("Aufgabe4Nachricht1")
						+ " " + Integer.toString(k) + " "
						+ messages.getString("Aufgabe4Nachricht2"));
			}

			BigInteger r = GMRKeyGenerator.generateReference(pubKey, k);
			Text2.append(messages.getString("Aufgabe4Ref") + " ");
			Text2.append(r.toString() + "\n");

			GMR myGMR = new GMR();

			BigInteger sig = myGMR.sign(privKey, m, r);
			Text2.append(messages.getString("Aufgabe4Sign") + " "
					+ sig.toString() + "\n");

			if (!myGMR.test(pubKey, m, r, sig)) {
				Text2.append(messages.getString("Aufgabe4Err1"));
			} else {
				Text2.append(messages.getString("Aufgabe4SignKorr"));
			}
			;
		} catch (Exception e) {
			Text2.append(messages.getString("Aufgabe4Err2") + " "
					+ e.getMessage() + "\n");
		}
		;
	};
};
