package praktikum;

import java.math.BigInteger;
import algorithms.*;

/**
 * Diese Klasse implementiert die Damgard-Hashfunktion. 
 */

public class Damgard{

    /**
     * Diese Methode implementiert die Damgard-Hashfunktion.
     * Die Nachricht m liegt dabei schon im BigInteger-Format vor.
     * Vereinfachend kann hier davon ausgegangen werden, daß m < n ist.
     * 
     * Es konnen die BigInteger-Methoden und zusätzlich die 
     * Algorithmen CRA, Legendre, SQRTMOD und die Methode
     * praefixfreiMessage() verwendet werden.
     *
     * @param key der Damgard-Schlüssel 
     * @param m die Nachricht
     * @return den Hashwert
     */
    
    public BigInteger hash(DamgardKey key, BigInteger m){
	try{

	    //----------------------------------------------------------
	    /* Hier Implementieren                                    */
					
 	    //----------------------------------------------------------
	    





	    /* nicht vergessen, den Hashwert zurückzugeben           */
	    
	    //---------------------------------------------------------

	} catch (Exception e){
	    System.out.println("Damgard.hash: "+e.getMessage());
	    e.printStackTrace();
	}
	return null;
    }

    /**
     * Die Prozedur praefixfreiMessage erzeugt aus einer Nachricht m eine präfixfrei
     * kodierte Nachricht m, indem ihre Bitlänge angehängt wird.
     * (um die Nachrichtenlänge resistent gegen das Invertieren der Nachricht zu machen,
     * wird zusätzlich eine 1 angehängt)
     *
     * @param m die Nachicht
     * @return die präfixfrei kodierte Nachricht
     */
    

    private BigInteger praefixfreiMessage(BigInteger m){
	BigInteger mPFrei = m.shiftLeft(5);
        BigInteger len = BigInteger.valueOf(mPFrei.bitLength());
	mPFrei = mPFrei.add(len.shiftLeft(1));
	mPFrei = mPFrei.add(BigInteger.ONE);
	return mPFrei;
    }


}
